/*****************************************************************************
 
                           Macromedia FileIO XObject
                                       
                         (c) Copyright 1993 Macromedia
                              All Rights Reserved

    Revision History:
 
 24may94	JT	Fixed append. use full path name for mFileName
       16feb93  PTM     Revised internal documentation
        9feb93  JT      mReadPICT returns file name
        9feb93  JT      Don't do any CR-LF conversion. Added mDosFileName

    !!@ fileio doc: cannot read or write more than 64K

 *****************************************************************************/

#include <windows.h>
#include <stdio.h>      // For remove
#include <stdlib.h>		// for _fullpath
#include "XObject.h"


/*
------------------------------------------------------------------------------
Function Prototypes:
------------------------------------------------------------------------------
*/

short __far __pascal __export LibMain(
    HANDLE hndInstance, WORD suDataSeg, WORD suHeapSize, LPSTR pCmdLine);
int __export __far __pascal WEP(int nParameter);

long __far __pascal __export _FileIO_mNew(
    LxMemHandle hOpenMode, LxMemHandle hNameOrType, 
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mDispose(
    LxProcTablePtr xtbl, LxMemHandle hFile);
LxMemHandle __far __pascal __export _FileIO_mFileName(
    LxProcTablePtr xtbl, LxMemHandle hFile);
LxMemHandle __far __pascal __export _FileIO_mNativeFileName(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mStatus(
    LxProcTablePtr xtbl, LxMemHandle hFile);
LxMemHandle __far __pascal __export _FileIO_mError(
    long lErrorCode, LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mSetPosition(
    long lPos, LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mGetPosition(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mGetLength(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mWriteChar(
    long lCharNum, LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mWriteString(
    LxMemHandle hData, LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mReadChar(
    LxProcTablePtr xtbl, LxMemHandle hFile);
LxMemHandle __far __pascal __export _FileIO_mReadLine(
    LxProcTablePtr xtbl, LxMemHandle hFile);
LxMemHandle __far __pascal __export _FileIO_mReadFile(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mReadWord(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mReadToken(
    LxMemHandle breakString, LxMemHandle skipString, 
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mGetFinderInfo(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mDelete(
    LxProcTablePtr xtbl, LxMemHandle hFile);
long __far __pascal __export _FileIO_mReadPICT(
    long nargs, LxValuePtr argp, LxProcTablePtr xtbl, LxMemHandle hFile);

long __far __pascal __export _FileIO_mSetOverrideDrive(
    long driverLetter, LxProcTablePtr xtbl, LxMemHandle hFile);

/*
------------------------------------------------------------------------------
Constants:
------------------------------------------------------------------------------
*/

// Maximum buffer size that _lread can handle
#define MAX_LREAD_SIZE  (0xFFFE)

#define FILEIO_TAB      0x09
#define FILEIO_LF       0x0A
#define FILEIO_CR       0x0D
#define FILEIO_EOF      0x26
#define FILEIO_CRLF_STR "\r\n"

#define FILEIO_OPEN_CAPTION " "
#define FILEIO_SAVE_CAPTION " "
#define FILEIO_DEF_EXT  "*.txt"
#define FILEIO_DEF_PATH "\\"

#define FILEIOE_SUCCESS         0
#define FILEIOE_MEM_ALLOC       1
#define FILEIOE_DIR_FULL        -33
#define FILEIOE_VOL_FULL        -34
#define FILEIOE_VOL_NOT_FOUND   -35
#define FILEIOE_IO_FAILURE      -36
#define FILEIOE_BAD_FILE_NAME   -37
#define FILEIOE_FILE_NOT_OPEN   -38
#define FILEIOE_TOO_MANY_OPEN   -42
#define FILEIOE_FILE_NOT_FOUND  -43
#define FILEIOE_NO_SUCH_DRIVE   -56
#define FILEIOE_EMPTY_DRIVE     -65
#define FILEIOE_DIR_NOT_FOUND   -120

/* following belong in WINDOWS.H (so there) */

#define OF_FROM_BEGIN   0
#define OF_FROM_CURR    1
#define OF_FROM_END     2

#define MAXSTRINGSIZE   255

/*
------------------------------------------------------------------------------
Types:
------------------------------------------------------------------------------
*/

typedef struct
{
    LxXObjHeader    head;
    LxMemHandle     hFileName;
    short           sFileID;
    short           sReadWrite;
}   FileIO, FAR * pFileIO;

/*
------------------------------------------------------------------------------
Variables:
------------------------------------------------------------------------------
*/

long    lFileIOError = 0;
HANDLE  hInst;

/*
------------------------------------------------------------------------------
FUNCTION        ||      LibMain()

Windows Entry Procedure for DLLs.  Called by LibEntry routine.
------------------------------------------------------------------------------
*/

short __far __pascal __export LibMain(
    HANDLE hndInstance, WORD suDataSeg, WORD suHeapSize, LPSTR pCmdLine)
{
    if (suHeapSize != 0)
    {
        if (! LocalInit( (UINT)suDataSeg, (UINT)NULL, (UINT)suHeapSize))
        {
            return (0);
        }
    }
    hInst = hndInstance;
    return (1);
}



//DJ20jul93/*
//DJ20jul93------------------------------------------------------------------------------
//DJ20jul93FUNCTION        ||      WEP()
//DJ20jul93
//DJ20jul93Windows Exit Procedure for DLLs.
//DJ20jul93------------------------------------------------------------------------------
//DJ20jul93*/
//DJ20jul93int __export __far __pascal WEP(int nParameter)
//DJ20jul93{
//DJ20jul93    return 1;
//DJ20jul93}


/*
------------------------------------------------------------------------------
Internal Functions:
------------------------------------------------------------------------------
*/

static BOOL GetOpenInfo(
    pFileIO pFile, LPSTR pstrOpenMode, LPSTR pstrNameOrType, 
    LxProcTablePtr xtbl);
static LxMemHandle PromptOpenFile(
    pFileIO pFile, LPSTR pstrType, LxProcTablePtr xtbl);
static LxMemHandle PromptSaveFile(
    pFileIO pFile, LPSTR pstrName, LxProcTablePtr xtbl);
static BOOL OpenTheFile( pFileIO pFile, LxProcTablePtr xtbl);

/*
------------------------------------------------------------------------------
Macros:
------------------------------------------------------------------------------
*/


/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mNew

Open a file and return a file reference object for it.

Arguments:
    hOpenMode       Option String (read,write,append,?read,?write,?append)
    hNameOrType     Filename string or file type (e.g. "TXT")
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mNew(
    LxMemHandle hOpenMode, LxMemHandle hNameOrType, 
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;
    LPSTR    pstrOpenMode;
    LPSTR    pstrNameOrType;

    lFileIOError = FILEIOE_SUCCESS;
    pstrOpenMode = xtbl->mem_Lock( hOpenMode);
    pstrNameOrType = xtbl->mem_Lock( hNameOrType);

    if ( xtbl->mem_SetSize(hFile, (long) sizeof(FileIO) )  != NULL)
    {
        pFile = xtbl->mem_Lock( hFile);

        pFile->sFileID = -1;
        pFile->hFileName = NULL;
        pFile->sReadWrite = OF_READ;

        if (GetOpenInfo(pFile, pstrOpenMode, pstrNameOrType, xtbl))
        {
            OpenTheFile(pFile, xtbl);
        }
        if ((lFileIOError != FILEIOE_SUCCESS) && (pFile->hFileName != NULL))
        {
            xtbl->mem_Dispose(pFile->hFileName);
        }
        xtbl->mem_Unlock( hFile);
    }
    else
    {
        lFileIOError = FILEIOE_MEM_ALLOC;
    }
    xtbl->mem_Unlock( hNameOrType);
    xtbl->mem_Unlock( hOpenMode);
    return (lFileIOError);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      GetOpenInfo

Initializes object instance variables to reflect the open mode and filename.
Called prior to actually opening the file.

Arguments:
    pFileIO         Pointer to FileIO object instance
    pstrOpenMode    Open mode string: read,write,append...
    pstrNameOrType  Filename string, or type string (e.g. "TXT")
    xtbl            Callback proc table
------------------------------------------------------------------------------
*/

static BOOL GetOpenInfo(
    pFileIO pFile, LPSTR pstrOpenMode, LPSTR pstrNameOrType, 
    LxProcTablePtr xtbl)
{
    char    strBuf[MAXSTRINGSIZE];
        
    if (lstrcmpi(pstrOpenMode, "read") == 0)
    {
        pFile->sReadWrite = OF_READ;
        //xtbl->ConvertMACToDosPath( pstrNameOrType, strBuf, MAXSTRINGSIZE);
        if (! _fullpath( strBuf, pstrNameOrType, MAXSTRINGSIZE))
        	lstrcpy( strBuf, pstrNameOrType); 
        pFile->hFileName = xtbl->string_New(strBuf);
    }
    else if (lstrcmpi(pstrOpenMode, "?read") == 0)
    {
        pFile->sReadWrite = OF_READ;
        pFile->hFileName = PromptOpenFile(pFile, pstrNameOrType, xtbl);
    }
    else if (lstrcmpi(pstrOpenMode, "write") == 0)
    {
        pFile->sReadWrite = OF_WRITE;
        if (! _fullpath( strBuf, pstrNameOrType, MAXSTRINGSIZE))
        	lstrcpy( strBuf, pstrNameOrType); 
        //xtbl->ConvertMACToDosPath( pstrNameOrType, strBuf, MAXSTRINGSIZE );
        pFile->hFileName = xtbl->string_New(strBuf);
    }
    else if (lstrcmpi(pstrOpenMode, "?write") == 0)
    {
        pFile->sReadWrite = OF_WRITE;
        xtbl->ConvertMACToDosPath( pstrNameOrType, strBuf, MAXSTRINGSIZE );
        pFile->hFileName = PromptSaveFile(pFile, strBuf, xtbl);
    }
    else if (lstrcmpi(pstrOpenMode, "append") == 0)
    {
        pFile->sReadWrite = OF_READWRITE;
        if (! _fullpath( strBuf, pstrNameOrType, MAXSTRINGSIZE))
        	lstrcpy( strBuf, pstrNameOrType); 
        //xtbl->ConvertMACToDosPath( pstrNameOrType, strBuf, MAXSTRINGSIZE );
        pFile->hFileName = xtbl->string_New(strBuf);
    }
    else if (lstrcmpi(pstrOpenMode, "?append") == 0)
    {
        pFile->sReadWrite = OF_READWRITE;
        pFile->hFileName = PromptOpenFile(pFile, pstrNameOrType, xtbl);
    }
    else
    {
        lFileIOError = FILEIOE_BAD_FILE_NAME;
    }
    return (lFileIOError == FILEIOE_SUCCESS);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      PromptOpenFile

Displays "Open" dialog box to prompt for existing filename.

Arguments:
    pFileIO         Pointer to FileIO object instance
    pstrType        Filename extension string (e.g., "TXT" for *.TXT file)
    xtbl            Callback proc table
------------------------------------------------------------------------------
*/

static LxMemHandle PromptOpenFile(
    pFileIO pFile, LPSTR pstrType, LxProcTablePtr xtbl)
{
    char    astrDefSpec[128];
    char    astrFileName[128];
    BOOL    ok;
        
    if (*pstrType != 0)
    {
        lstrcpy(astrDefSpec, "*.");
        lstrcat(astrDefSpec, pstrType);
        astrDefSpec[5] = 0;     // Truncate spec to 3 chars + 2 for "*."
    }
    else
    {
        lstrcpy(astrDefSpec, "*.*");
    }

    astrFileName[0] = 0;
    ok = xtbl->fileDlg_Open( FILEIO_OPEN_CAPTION, astrDefSpec, astrFileName );
    if (! ok)
    {
        lFileIOError = FILEIOE_FILE_NOT_FOUND;
    }
    return (xtbl->string_New(astrFileName));
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      PromptSaveFile

Displays "Save As" dialog box to prompt for output filename.

Arguments:
    pFileIO         Pointer to FileIO object instance
    pstrType        Filename extension string (e.g., "TXT" for *.TXT file)
    xtbl            Callback proc table
------------------------------------------------------------------------------
*/

static LxMemHandle PromptSaveFile(
    pFileIO pFile, LPSTR pstrName, LxProcTablePtr xtbl)
{
    BOOL    ok;
    char    astrFileName[MAXSTRINGSIZE];
        
    lstrcpy(astrFileName, pstrName);

    ok = xtbl->fileDlg_SaveAs( FILEIO_SAVE_CAPTION, 
                               FILEIO_DEF_EXT, astrFileName );
    if (! ok)
    {
        lFileIOError = FILEIOE_FILE_NOT_FOUND;
    }
    return xtbl->string_New( astrFileName );
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      OpenTheFile

Creates or Opens the requested file, as specified by the hFileName
and sReadWrite instance variables of pFileIO.  Sets sFileID to the
newly opened file.  Returns TRUE if successful.

Arguments:
    pFileIO         Pointer to FileIO object instance
    xtbl            Callback proc table
------------------------------------------------------------------------------
*/

static BOOL OpenTheFile(pFileIO pFile, LxProcTablePtr xtbl)
{
    LPSTR    pstrName;

    pstrName = xtbl->mem_Lock( pFile->hFileName);

    switch (pFile->sReadWrite)
    {
    case OF_READ:
        pFile->sFileID = _lopen(pstrName, pFile->sReadWrite);
        break;

    case OF_WRITE:
        pFile->sFileID = _lcreat(pstrName, 0);  /* 0 = normal attrs */

        /*
         * If we weren't able to create (or truncate) the file, it must
         * already exist, but be inaccessible. Try opening it as a hidden
         * file. If that fails, try opening it as a system file. If that
         * fails, the this is really and truly an error!
         */

        if (pFile->sFileID == -1)
            pFile->sFileID = _lcreat(pstrName, 2);  /* 2 = hidden */
        if (pFile->sFileID == -1)
            pFile->sFileID = _lcreat(pstrName, 3);  /* 3 = system */
        break;

    case OF_READWRITE:
        pFile->sFileID = _lopen(pstrName, pFile->sReadWrite);
        if (pFile->sFileID == -1)
        {
            /*
             * Failed to open an existing file, so create a new one!
             */
            pFile->sFileID = _lcreat(pstrName, 0);
        }
        else
        {
            /*
             * Got an existing file, so fast-forward to the end.
             */
            _llseek(pFile->sFileID, 0L, OF_FROM_END);   /* go to EOF */
        }
        break;
    }

    if (pFile->sFileID == -1)
    {
        //DJ07may93
        // This used to return "I/O error" all the time.  Now it returns
        // "file not found" if the file was being opened for read, and
        // "I/O error" if the file is being created (and fails).
        if (pFile->sReadWrite == OF_READ)
            lFileIOError = FILEIOE_FILE_NOT_FOUND;
        else
            lFileIOError = FILEIOE_IO_FAILURE;
    }

    xtbl->mem_Unlock( pFile->hFileName);
    return (lFileIOError == FILEIOE_SUCCESS);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mDispose

Dispose of a FileIO object instance.  Note: This method does not close or
delete any open files.  

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mDispose(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;

    lFileIOError = FILEIOE_SUCCESS;
    pFile =  xtbl->mem_Lock( hFile);

    if (_lclose(pFile->sFileID) != 0)
    {
        lFileIOError = FILEIOE_FILE_NOT_OPEN;
    }
    if (pFile->hFileName != NULL)
    {
        xtbl->mem_Dispose(pFile->hFileName);
    }

    xtbl->mem_Unlock( hFile);
    xtbl->xobj_Dispose( hFile );
        
    return (lFileIOError);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mFileName

Return the filename string of the open file.  Note that a Macintosh-style
path expression is returned.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

LxMemHandle __far __pascal __export _FileIO_mFileName(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    LxMemHandle  hName;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    hName = xtbl->mem_Clone(pFile->hFileName);
    if (hName != NULL)
    {
        xtbl->ConvertDosPathToMAC( (LPSTR)*hName );
    }
                
    xtbl->mem_Unlock( hFile);

    return (hName);
}
/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mNativeFileName

Return the "native" filename string of the open file.  Note that a DOS-style
path expression is returned.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

LxMemHandle __far __pascal __export _FileIO_mNativeFileName(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    LxMemHandle  hName;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    hName = xtbl->mem_Clone(pFile->hFileName);
                
    xtbl->mem_Unlock( hFile);
        
    return (hName);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mStatus

Return the error status code of the last FileIO method call.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mStatus(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    return (lFileIOError);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mError

Return the error string corresponding to the lErrorCode paramter passed.

Arguments:
    lErrorCode      Error code returned by mStatus method
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

LxMemHandle __far __pascal __export _FileIO_mError(
    long lErrorCode, LxProcTablePtr xtbl, LxMemHandle hFile)
{
    LPSTR    pstrMsg;

    switch ((short) lErrorCode)
    {
    case FILEIOE_SUCCESS:
        pstrMsg = "";
        break;
    case FILEIOE_MEM_ALLOC:
        pstrMsg = "Memory allocation failure";
        break;
    case FILEIOE_DIR_FULL:
        pstrMsg = "File directory full";
        break;
    case FILEIOE_VOL_FULL:
        pstrMsg = "Volume full";
        break;
    case FILEIOE_VOL_NOT_FOUND:
        pstrMsg = "Volume not found";
        break;
    case FILEIOE_IO_FAILURE:
        pstrMsg = "I/O Error";
        break;
    case FILEIOE_BAD_FILE_NAME:
        pstrMsg = "Bad file name";
        break;
    case FILEIOE_FILE_NOT_OPEN:
        pstrMsg = "File not open";
        break;
    case FILEIOE_TOO_MANY_OPEN:
        pstrMsg = "Too many files open";
        break;
    case FILEIOE_FILE_NOT_FOUND:
        pstrMsg = "File not found";
        break;
    case FILEIOE_NO_SUCH_DRIVE:
        pstrMsg = "No such drive";
        break;
    case FILEIOE_EMPTY_DRIVE:
        pstrMsg = "No disk in drive";
        break;
    case FILEIOE_DIR_NOT_FOUND:
        pstrMsg = "Directory not found";
        break;
    default:
        pstrMsg = "Unknown error";
        break;
    }
    return (xtbl->string_New(pstrMsg));
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mSetPosition

Set the file position to the value passed in lPos.

Arguments:
    lPos            Byte offset within the file
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mSetPosition(
    long lPos, LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    if (_llseek(pFile->sFileID, lPos, OF_FROM_BEGIN) == -1)
    {
        lFileIOError = FILEIOE_FILE_NOT_OPEN;
    }
    xtbl->mem_Unlock( hFile);
    return (lFileIOError);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mGetPosition

Return the current file position

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mGetPosition(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;
    long    lPos;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    if ((lPos = _llseek(pFile->sFileID, 0L, OF_FROM_CURR)) == -1)
    {
        lFileIOError = FILEIOE_FILE_NOT_OPEN;
    }
    xtbl->mem_Unlock( hFile);
    return (lPos);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mGetLength

Return the size of the file (in bytes).

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mGetLength(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;
    long    lPos;
    long    lLength;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    if ((lPos = _llseek(pFile->sFileID, 0L, OF_FROM_CURR)) == -1)
    {
        lFileIOError = FILEIOE_FILE_NOT_OPEN;
    }
    else
    {
        lLength = _llseek(pFile->sFileID, 0L, OF_FROM_END);
        _llseek(pFile->sFileID, lPos, OF_FROM_BEGIN);
    }
    xtbl->mem_Unlock( hFile);
    return (lLength);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mWriteChar

Write a single character (given by its ASCII code) to the file.

Arguments:
    lCharNum        Input character (ASCII code)
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mWriteChar(
    long lCharNum, LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;
    BYTE     strChar;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    strChar = (BYTE) lCharNum;

    if (_lwrite(pFile->sFileID, &strChar, 1) != 1)
    {
        lFileIOError = FILEIOE_IO_FAILURE;
    }
    xtbl->mem_Unlock( hFile);
    return (lFileIOError);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mWriteString

Write a null-terminated string to the file.

Arguments:
    lData           LxMemHandel to string data
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mWriteString(
    LxMemHandle hData, LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;
    LPSTR   pstrData;
    UINT    len;
        
    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);
    pstrData = xtbl->mem_Lock( hData);
    len = (UINT) lstrlen( pstrData );
        
    if (_lwrite(pFile->sFileID, pstrData, len) != (UINT)len)
    {
        lFileIOError = FILEIOE_IO_FAILURE;
    }

    xtbl->mem_Unlock( hData);
    xtbl->mem_Unlock( hFile);
    return (lFileIOError);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mReadChar

Read the next character of the file and return it as an ASCII code value.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mReadChar(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO pFile;
    BYTE    strChar;
    long    lCharNum;
    short   sReadCount;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    sReadCount = _lread(pFile->sFileID, &strChar, 1);
    if (sReadCount < 0)
    {
        lFileIOError = FILEIOE_IO_FAILURE;
        lCharNum = -1;
    }
    else if (sReadCount == 1)
    {
        lCharNum = strChar;
    }
    xtbl->mem_Unlock( hFile);
    return (lCharNum);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mReadLine

Read the next line of the file (up to and including the next RETURN character)
and return it as a string.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

LxMemHandle __far __pascal __export _FileIO_mReadLine(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    short       sReadCount;
    BYTE        strChar = 0;
    BYTE        astrBuf[129];
    short       sBufCount = 0;
    LxMemHandle hLine = NULL;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock ( hFile );

    hLine = xtbl->mem_New( 0, FALSE );
    while (strChar != FILEIO_CR)
    {
        if ((sReadCount = _lread(pFile->sFileID, &strChar, 1)) < 1)
        {
            if (sReadCount != 0)
            {
                lFileIOError = FILEIOE_IO_FAILURE;
            }
            break;
        }
        if (sBufCount >= sizeof(astrBuf) - 1)
        {
            if (! xtbl->mem_AppendPtr(hLine, astrBuf, sBufCount))
            {
                break;
            }
            sBufCount = 0;
        }
        astrBuf[sBufCount++] = strChar;
    }
    astrBuf[sBufCount++] = 0;
    xtbl->mem_AppendPtr( hLine, astrBuf, sBufCount );

    xtbl->mem_Unlock( hFile);
    return (hLine);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mReadFile

Read from the current file position through the end of the file
and return the data read as a string.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

LxMemHandle __far __pascal __export _FileIO_mReadFile(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    long        lCount;
    long        lPos, lEof;
    LxMemHandle hData;
    LPSTR       pbData;

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    // Determine size of file, begining from current position.
    lPos = _llseek(pFile->sFileID, 0L, OF_FROM_CURR);
    lEof = _llseek(pFile->sFileID, 0L, OF_FROM_END);
    _llseek(pFile->sFileID, lPos, OF_FROM_BEGIN);

    lCount = lEof - lPos;
    if (lCount > MAX_LREAD_SIZE)
        lCount = MAX_LREAD_SIZE;

    if ((lPos < 0) || (lEof < 0))
    {
        lFileIOError = FILEIOE_FILE_NOT_OPEN;
        hData = xtbl->string_New( "" );
        goto home;
    }
    if (lCount <= 0)            /* normal EOF */
    {
        xtbl->mem_Unlock( hFile);
        return xtbl->string_New( "" );
    }
    if ((hData = xtbl->mem_New( lCount + 1, FALSE)) == NULL)
    {
        /* -- No memory for string. -- */
        lFileIOError = FILEIOE_MEM_ALLOC;
        hData = 0;
        goto home;
    }
    pbData = xtbl->mem_Lock( hData);

    if (_lread(pFile->sFileID, pbData, (UINT)lCount) != (UINT)lCount)
    {
        /* -- Read failed. Deallocated and return null string -- */
        lFileIOError = FILEIOE_IO_FAILURE;
        xtbl->mem_Unlock( hData);
        xtbl->mem_Dispose ( hData );
        hData = xtbl->string_New( "" );
        goto home;
    }
    xtbl->mem_Unlock( hData);

home:
    xtbl->mem_Unlock( hFile);
    return (hData);
}

#define BUFFSIZ 512
enum searchmode  {skipping,saving,done};

/*
------------------------------------------------------------------------------
FUNCTION        ||      Read1Char

Read next character from file.
------------------------------------------------------------------------------
*/

static char Read1Char(short sFileID, enum searchmode *searching)
{
    char cbuf;
    long count = 1;

    if (_lread(sFileID, &cbuf, (UINT)count) != (UINT)count)
    {
        /* -- EOF read -- */
        *searching += 1;
    }
                
    return (cbuf);
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      SkipReadBreak

Create a string from file stream. Skip over chars in argument "skips"
and stop at any character in argument "breaks."
Code taken from MAC FileIO. ie. I know it's ugly.
------------------------------------------------------------------------------
*/

static LxMemHandle SkipReadBreak(
    short sFileID, char *breaks, char *skips, LxProcTablePtr xtbl)
{
    LxMemHandle     strHdl;
    char            buff[BUFFSIZ];
    short           len = 0;
    long            hLen = 0;
    register char   *cp,newChar,cmpChar;
    enum searchmode searching;
    short           pushit;
    long            newPos;

    if (skips[0])
    {
        pushit = TRUE;
        searching = skipping;   /* if something to skip start skipping */
    }
    else
    {
        pushit = FALSE;
        searching = saving;     /* start saving - no skips */
    }

    strHdl = xtbl->mem_New(1, TRUE/*-zeroInit-*/);

    /* prime the pumps */
    newChar = Read1Char(sFileID, &searching);

    if (searching == skipping)  /* first skip white space chars */
    {
        cp = skips;
        while (cmpChar = *cp++) /* search for skip char */
        {
            if (cmpChar == newChar)     /* should we eat it?? */
            {
                /* eat it - less calories, more filling! */
                newChar = Read1Char(sFileID,&searching);
                /* look for more yummy white space */
                cp = skips;
            }
        }
        ++searching;
    }

    while (searching == saving) /* save while looking for break char */
    {
        buff[len++] = newChar;  /* Save the char into the buffer */
        if (len>=BUFFSIZ)       /* time to write into handle */
        {
            hLen = xtbl->mem_GetSize(strHdl);
            if (! xtbl->mem_SetSize(strHdl, hLen + BUFFSIZ) )
                goto fail;

            //DJ01jun93--Fixed bug--Dest and source were reversed!
            // Append bytes collected from fixed-size buff into the string.
            xtbl->mem_Copy((char *)(*strHdl)+ (hLen-1), buff, BUFFSIZ);
            len = 0;
        }

        cp = breaks;
        while (cmpChar = *cp++) /* search for break char */
        {
            if (cmpChar == newChar)     /* got it - we're done */
            {
                ++searching;
                goto done;
            }
        }
        newChar = Read1Char(sFileID, &searching);       /* read next char */
    }

done:
    /* push back the break character if not a singleton */
    hLen = xtbl->mem_GetSize(strHdl);
    if (pushit && (len+hLen > 1))
    {
        if ((newPos = _llseek(sFileID, 0L, OF_FROM_CURR)) != -1)
        {
            --newPos;
            if (_llseek(sFileID, newPos, OF_FROM_BEGIN) != -1)
            {
                if (hLen+len > 1)
                --len;
            }
        }
    }

    /* return the buff and the handle combined as a string */
    if (! xtbl->mem_SetSize(strHdl, hLen + len) )
        goto fail;
    xtbl->mem_Copy( (char *)(*strHdl) + (hLen-1), buff, len);
    (*(char **)strHdl)[hLen + len-1] = 0;       /* zap last byte */
    return strHdl;

fail:
    xtbl->mem_Dispose( strHdl );
    return 0;
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mReadWord

Read the word of the file and return it as a string.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mReadWord(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    LxMemHandle hdl;
        
    lFileIOError = FILEIOE_SUCCESS;
        
    pFile = xtbl->mem_Lock( hFile);
        
    hdl = SkipReadBreak( pFile->sFileID, " \r"/*-break-*/, 
                                         " "/*-skip-*/, xtbl );
    xtbl->mem_Unlock( hFile);
    return (long)hdl;
}


/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mReadToken

Read next token from the file and return it as a string.

Arguments:
    breakString     String of "break" characters (after token)
    skipString      String of characters to skip (before token)
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mReadToken(
    LxMemHandle breakString, LxMemHandle skipString, 
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    LPSTR       breakPtr;
    LPSTR       skipPtr;
    LxMemHandle hdl;
        
    lFileIOError = FILEIOE_SUCCESS;
        
    pFile = xtbl->mem_Lock( hFile);
    breakPtr = xtbl->mem_Lock( breakString );
    skipPtr = xtbl->mem_Lock( skipString );
        
    hdl = SkipReadBreak( pFile->sFileID, breakPtr, skipPtr, xtbl );
        
    xtbl->mem_Unlock( breakString );
    xtbl->mem_Unlock( skipString );
    xtbl->mem_Unlock( hFile);
    return (long)hdl;
}

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mSetFinderInfo

Set the "finder" info attrributes of a file.  This is MAC specific.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mSetFinderInfo(
    LxMemHandle typeString, LxMemHandle creatorString, 
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    // Null implementation.
    return -1;
}



/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mGetFinderInfo

Get the "finder" info attrributes of a file.  This is MAC specific.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mGetFinderInfo(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    // Null implementation.
    return (long) xtbl->string_New( "" );
}
        

/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mDelete

Delete the file and dispose of me.

Arguments:
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mDelete(
    LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    LPSTR       pFileName;
        
    lFileIOError = FILEIOE_SUCCESS;
    pFile =  xtbl->mem_Lock( hFile);

    if (_lclose(pFile->sFileID) != 0)
    {
        lFileIOError = FILEIOE_FILE_NOT_OPEN;
    }
    if (pFile->hFileName != NULL)
    {
        pFileName = xtbl->mem_Lock( pFile->hFileName);
        remove( pFileName );
        xtbl->mem_Unlock( pFile->hFileName );
                
        xtbl->mem_Dispose(pFile->hFileName);
    }
    xtbl->mem_Unlock( hFile);
    xtbl->xobj_Dispose( hFile );
        
    return 0;
}

/* ------------------------------------------------------------------------ */
// Swap the bytes of a short
short  mem_XShort(short x)
{
	register unsigned char temp;
	union
	{
		short oneWord;
		unsigned char twoBytes[2];
	} Moto;
	Moto.oneWord = x;
	/* swap two end bytes */
	temp = Moto.twoBytes[1];
	Moto.twoBytes[1] = Moto.twoBytes[0];
	Moto.twoBytes[0] = temp;
	return (Moto.oneWord);
}
        
/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_mReadPICT

Arguments:
    nargs           Number of arguments. Should be zero (0)
    argp            Array of arguments.  argp[0] used to return value
    xtbl            Callback proc table
    hFile           LxMemHandle to object instance
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mReadPICT(
    long nargs, LxValuePtr argp, LxProcTablePtr xtbl, LxMemHandle hFile)
{
    pFileIO     pFile;
    LxMemHandle pictHdl = 0;
    long        len;
    char _huge *pictPtr;
		UINT				cbRead;
		unsigned char *cp;
#define MAX_LREAD_BYTES	((long)(0xFFFE))

    lFileIOError = FILEIOE_SUCCESS;
    pFile = xtbl->mem_Lock( hFile);

    if (pFile->sFileID == -1)
			goto errorReturn;

		len = _FileIO_mGetLength( xtbl, hFile);
		if (lFileIOError != FILEIOE_SUCCESS)
			goto errorReturn;
		
		len = len - 512;
		if (len < 0)
			goto errorReturn;
		
		_FileIO_mSetPosition( (long)512, xtbl, hFile);
		if (lFileIOError != FILEIOE_SUCCESS)
			goto errorReturn;

    pictHdl = xtbl->mem_New( len, FALSE);
    if (! pictHdl)
        goto errorReturn;
				
		pictPtr = xtbl->mem_Lock( pictHdl );
		do {
			cbRead = _lread(pFile->sFileID, pictPtr, MAX_LREAD_BYTES);
			len -= cbRead;
			pictPtr += cbRead;
		} while (len > 0 && cbRead > 0);

    xtbl->mem_Unlock( pictHdl);
		
#define VERSION_OFFSET 10	// offset to version opcode in the picture data
		cp = (unsigned char *)*pictHdl + VERSION_OFFSET;
		
		if (! ((cp[0] == 0x11 && cp[1] == 0x01) ||
		 		(cp[0] == 0x00 && cp[1] == 0x11 && cp[2] == 0x02 && cp[3] == 0xff)) )
		{
				// Wrong format.
				goto errorReturn;
		}
		// Correct byte order of first 5 short. Len word and rect frame.
		xtbl->mem_ReverseBytes( *pictHdl, "2", 2/*entrySize*/, 5*2/*len*/);
		
		// Successful return.
		// Fill in the return value
		argp[0].ty = TY_PICTURE;
		argp[0].it = (long)pictHdl;
    goto home;
        
errorReturn:
    // Bad news. Clean up and go home.
    if (pictHdl)
        xtbl->mem_Dispose( pictHdl );
				
home:
    xtbl->mem_Unlock( hFile);
    return 0;
 }


/*
------------------------------------------------------------------------------
FUNCTION        ||      _FileIO_SetOverrideDrive

Set override drive to use when loading linked castmembers.
Returns old override drive setting.

Arguments:
    driverLetter    Character to code of new driver override letter or 0 to clear
------------------------------------------------------------------------------
*/

long __far __pascal __export _FileIO_mSetOverrideDrive(
    long driverLetter, LxProcTablePtr xtbl, LxMemHandle hFile)
{
    return xtbl->SetOverrideDrive( (char)driverLetter);
}


